Count Good Triplets in an Array | Segment Tree Concepts & Qns | Video 12 | Leetcode 2179 | MIK

Subscribers:
92,300
Published on ● Video Link: https://www.youtube.com/watch?v=gRF7k0dNr7k



Duration: 0:00
7,437 views
401


iPad PDF Link - https://github.com/MAZHARMIK/Interview_DS_Algo/blob/master/iPad PDF Notes/Leetcode-2179-Notes.pdf
Whatsapp Community Link : https://www.whatsapp.com/channel/0029Va6kVSjICVfiVdsHgi1A

Segment Tree Concepts Playlist -    • Segment Tree | Introduction | Basics ...  

Hi Everyone, this is the 12th video of our Playlist "Segment Tree Concepts & Qns" by codestorywithMIK
Now we will be solving a very good problem based on Segment Tree - Count Good Triplets in an Array | Segment Tree Concepts & Qns | Video 12 | Leetcode 2179 | codestorywithMIK

My major focus in this problem will be to explain why this problem is a Segment Tree problem and the intuition or thought process behind solving the problem.

I will explain the intuition so easily that you will never forget and start seeing this as cakewalk EASYYY. We will do live coding after explanation and see if we are able to pass all the test cases. Also, please note that my Github solution link below contains both C++ as well as JAVA code.

Problem Name : Count Good Triplets in an Array | Segment Tree Concepts & Qns | Video 12 | Leetcode 2179 | codestorywithMIK
Company Tags :
My solutions on Github(C++ & JAVA) - https://github.com/MAZHARMIK/Interview_DS_Algo/blob/master/Segment Tree/Count Good Triplets in an Array.cpp
Leetcode Link : https://leetcode.com/problems/count-good-triplets-in-an-array


My DP Concepts Playlist :    • Roadmap for DP | How to Start DP ? | ...  
My Graph Concepts Playlist :    • Graph Concepts & Qns - 1 : Graph will...  
My Segment Tree Concepts Playlist :    • Segment Tree | Introduction | Basics ...  
My Recursion Concepts Playlist :    • Introduction | Recursion Concepts And...  
Trie Playlist -    • Word Search II (Google, Amazon, Meta,...  
Difference Array Technique: Concepts & Qns :    • Introduction | What | How | Differenc...  
My GitHub Repo for interview preparation : https://github.com/MAZHARMIK/Interview_DS_Algo
Instagram : https://www.instagram.com/codestorywithmik/
Facebook : https://www.facebook.com/people/codestorywithmik/100090524295846/
Twitter : https://twitter.com/CSwithMIK
Subscribe to my channel :    / @codestorywithmik  

╔═╦╗╔╦╗╔═╦═╦╦╦╦╗╔═╗
║╚╣║║║╚╣╚╣╔╣╔╣║╚╣═╣
╠╗║╚╝║║╠╗║╚╣║║║║║═╣
╚═╩══╩═╩═╩═╩╝╚╩═╩═╝


Video Summary :
The core idea behind the solution is to efficiently count the number of "good triplets" between two arrays, where a good triplet is defined by a specific relative ordering. To do this, we first map the elements of one array (nums2) to their indices, so we can quickly understand the position of any value in that array.
Then, as we iterate through the other array (nums1), we treat it as a timeline, where we gradually build up knowledge of the elements we've seen so far. For each element, we want to count how many previously seen elements appear before it in nums2 (left common) and how many elements that come after it in nums2 can be paired with these earlier ones (right common).
To track and query these counts efficiently, a segment tree is used. It allows us to quickly update the positions we've encountered and query how many values lie in a certain range, which helps in determining how many valid triplets can be formed with the current element as the middle of the triplet.


✨ Timelines✨
00:00 - Introduction
0:09 - Motivation
0:28 - Problem Explanation
4:51 - Thought Process Brute Force
6:53 - How to improve from Brute Force + Core Logic
18:13 - Example Dry Run - How to find Count
29:43 - Why we need Segment Tree ?
37:19 - Segment Tree Example Dry Run
54:43 - Coding it up

#MIK #mik #Mik
#coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge #leetcodequestions #leetcodechallenge #hindi #india #coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge #leetcodequestions #leetcodechallenge #hindi #india #hindiexplanation #hindiexplained #easyexplaination #interview#interviewtips #interviewpreparation #interview_ds_algo #hinglish #github #design #data #google #video #leetcode #leetcodesolutions #leetcodequestionandanswers #code #learning #dsalgo #dsa #coding #programming #100daysofcode #developers #datastructures #algorithms #softwareengineering #computerscience #pythoncoding #codinglife #coderlife #javascript #datascience #leetcodesolutions #leetcodedailychallenge #codinginterview #interviewprep #technicalinterview #interviewtips #interviewquestions #codingchallenges #interviewready #dsa #hindi #india #hindicoding #hindiprogramming #hindiexplanation videomarketing #codestorywithmik #codestorywithmick #codestorywithmikc #codestorywitmik #codestorywthmik #codstorywithmik #codestorywihmik #codestorywithmiik #codeistorywithmik #codestorywithmk #codestorywitmick #codestorymik #codestorwithmik




Other Videos By codestorywithMIK


5 days agoCount of Interesting Subarrays | Using Studied Concept | Dry Run | Leetcode 2845 | codestorywithMIK
6 days agoCount Complete Subarrays in an Array | Khandani Template | Dry Run | Leetcode 2799 |codestorywithMIK
2025-04-22Count Largest Group | Simple Simulation | Dry Run | Leetcode 1399 | codestorywithMIK
2025-04-22Count the Number of Ideal Arrays | Detailed Explanation | Explained Maths | Leetcode 2338 | MIK
2025-04-22Modular nCr using Fermat’s Little Theorem | Beginner Friendly Explanation | Code | codestorywithMIK
2025-04-20Count the Hidden Sequences | Detailed Explanation | Maths | Leetcode 2145 | codestorywithMIK
2025-04-20Rabbits in Forest | Detailed Explanation | Maths Behind It | Leetcode 781 | codestorywithMIK
2025-04-17Count Equal and Divisible Pairs in an Array | Brute Force | Optimal | Detailed Maths | Leetcode 2176
2025-04-15Count the Number of Good Subarrays | Thought Process | Khandani Template | Leetcode 2537 | MIK
2025-04-15Count Good Triplets in an Array | Segment Tree Concepts & Qns | Video 12 | Leetcode 2179 | MIK
2025-04-13Count Good Triplets | Simple Approach | Slight Improvements | Leetcode 1534 | codestorywithMIK
2025-04-12Find the Count of Good Integers | Detailed Approach | Step By Step | Leetcode 3272 |codestorywithMIK
2025-04-10Count Symmetric Integers | 2 Detailed Approaches | Leetcode 2843 | codestorywithMIK
2025-04-10Count the Number of Powerful Integers | Detailed Thought Process | Leetcode 2999 | codestorywithMIK
2025-04-09Youtube Audio Track Feature | Change Audio Language | codestorywithMIK
2025-04-08Minimum Number of Operations to Make Elements in Array Distinct | 2 Approaches | Leetcode 3396 | MIK
2025-04-07Partition Equal Subset Sum | Recursion | Memo | Tree Diagram | Leetcode 416 | codestorywithMIK
2025-04-04Lowest Common Ancestor of Deepest Leaves | 2 Approaches | Leetcode 1123 | codestorywithMIK
2025-04-02Auto-translate the captions to any language | YouTube
2025-04-02Maximum Value of an Ordered Triplet I | Multiple Approaches | Leetcode 2873 | codestorywithMIK
2025-03-30Legends aren't defined by their successes